routes/web.php
<?php

use App\Http\Controllers\CsvController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('home', 'HomeController@index')->name('home');
Route::get('export', 'CsvController@export')->name('export');
Route::post('import', 'CsvController@import')->name('import');
Route::resource('csv', 'CsvController');

app/Csv.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Csv extends Model
{
    protected $table = 'csv';
    protected $fillable = ['technology', 'description', 'experience'];

}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/CsvController.php
<?php

namespace App\Http\Controllers;

use App\Csv;
use App\Exports\CsvExport;
use App\Imports\CsvImport;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Redirect;
use Maatwebsite\Excel\Facades\Excel;

class CsvController extends Controller
{
    public function export()
    {
        return Excel::download(new CsvExport, 'data.csv');
    }

    public function import()
    {
        Excel::import(new CsvImport, request()->file('file'));

        return back();
    }


    public function index()
    {
        return view('csv/index', [
            'data' => Csv::all()
        ]);
    }

    public function show($id)
    {
        return view('csv/show', [
            'data' => Csv::find($id)
        ]);
    }

    public function edit($id)
    {
        return view('csv/edit', [
            'data' => Csv::find($id)
        ]);
    }

    public function update(Request $request, Csv $csv)
    {
        $request->validate([
            'technology' => 'required',
            'description' => 'required',
            'experience' => 'required',
        ]);

        $csv->update($request->all());
        $csv->save();

        return redirect()->route('csv.index')
            ->with('success','Product updated successfully');
    }

}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use App\Csv;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     * @return Renderable
     */
    public function index(): Renderable
    {
        return view('home', [
            'csv' => Csv::all()
        ]);
    }
}

resources/views/csv/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="w-75 mx-auto">
        <div class="row" style="margin-bottom: 20px;">
            <div class="col-lg-12 margin-tb">
                <div class="pull-left">
                    <h3>Edit Data</h3>
                </div>
            </div>
        </div>

        @if ($errors->any())
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.<br><br>
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif

        <form action="{{ route('csv.update', $data->id) }}" method="POST">
            @csrf
            @method('PUT')

            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>technology:</strong>
                        <input type="text" name="technology" value="{{ $data->technology }}" class="form-control">
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>description:</strong>
                        <input type="text" name="description" value="{{ $data->description }}" class="form-control">
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12">
                    <div class="form-group">
                        <strong>experience:</strong>
                        <input type="text" class="form-control" name="experience" value="{{ $data->experience }}">
                    </div>
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                    <button type="submit" class="btn btn-success form-control">Update</button>
                </div>
            </div>

        </form>
    </div>
@endsection

resources/views/csv/index.blade.php
@extends('layouts.app')

@section('content')
    <table class="table table-striped table-bordered">
        <thead>
        <tr class="text-center">
            <td>ID</td>
            <td>Technology</td>
            <td>Description</td>
            <td>Experience</td>
            <td>Action</td>
        </tr>
        </thead>
        <tbody>
        @foreach($data as $key => $value)
            <tr class="text-center">
                <td>{{ $value->id }}</td>
                <td>{{ $value->technology }}</td>
                <td>{{ $value->description }}</td>
                <td>{{ $value->experience }}</td>

                <td class="d-flex justify-content-around">

                    <!-- delete the shark (uses the destroy method DESTROY /sharks/{id} -->
                    <!-- we will add this later since its a little more complicated than the other two buttons -->

                    <!-- show the shark (uses the show method found at GET /sharks/{id} -->
                    <a class="btn btn-small btn-success" href="{{ URL::to('csv/' . $value->id) }}">Show Record</a>

                    <!-- edit this shark (uses the edit method found at GET /sharks/{id}/edit -->
                    <a class="btn btn-small btn-info" href="{{ URL::to('csv/' . $value->id . '/edit') }}">Edit Record</a>

                </td>
            </tr>

        @endforeach
        </tbody>
    </table>
@endsection

resources/views/csv/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="card text-center w-75 mx-auto">
        <div class="card-header">
            Record Of {{ $data->created_at }}
        </div>
        <div class="card-body">
            <h5 class="card-title">Technology: <strong>{{ $data->technology }}</strong></h5>
            <h5 class="card-title">Description: <strong>{{ $data->description }}</strong></h5>
            <h5 class="card-title">Year of Experience: <strong>{{ $data->experience }}</strong></h5>
            <a class="btn btn-small btn-info" href="{{ URL::to('csv/' . $data->id . '/edit') }}">Edit Record</a>
        </div>
        <div class="card-footer text-muted">
            Record Of {{ $data->updated_at }}
        </div>
    </div>

@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    <div class="container">
                        <div class="card-body">
                            <form action="{{ route('import') }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                <input type="file" name="file" class="form-control" required>
                                <br>
                                <button class="btn btn-success">Import User Data</button>
                                <a class="btn btn-warning" href="{{ route('export') }}">Export User Data</a>
                                <a class="btn btn-info" href="{{ URL::to('csv/') }}">List Data</a>
                            </form>
                        </div>
                    </div>

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    Portfolio
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>